Objects and environments
Create Environment
Preview. Usable today, but this endpoint can change before it is stable, without a new Kite-Version. Changes are announced before they ship.
Register a background scene (USD). Usable in tasks that expose a background slot.
POST
/
v1
/
environments
Create Environment
curl --request POST \
--url https://api.kiteml.com/v1/environments \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"name": "<string>",
"description": "<string>",
"usd_uri": "<string>",
"glb_uri": "<string>",
"upload": {
"filename": "<string>",
"content_type": "<string>",
"size_bytes": 2
},
"object_min_z": 123,
"spawn_zones": [
{}
],
"initial_pose": {},
"up_axis": "<string>",
"rotate_deg": [
123
]
}
'import requests
url = "https://api.kiteml.com/v1/environments"
payload = {
"name": "<string>",
"description": "<string>",
"usd_uri": "<string>",
"glb_uri": "<string>",
"upload": {
"filename": "<string>",
"content_type": "<string>",
"size_bytes": 2
},
"object_min_z": 123,
"spawn_zones": [{}],
"initial_pose": {},
"up_axis": "<string>",
"rotate_deg": [123]
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
name: '<string>',
description: '<string>',
usd_uri: '<string>',
glb_uri: '<string>',
upload: {filename: '<string>', content_type: '<string>', size_bytes: 2},
object_min_z: 123,
spawn_zones: [{}],
initial_pose: {},
up_axis: '<string>',
rotate_deg: [123]
})
};
fetch('https://api.kiteml.com/v1/environments', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.kiteml.com/v1/environments",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'name' => '<string>',
'description' => '<string>',
'usd_uri' => '<string>',
'glb_uri' => '<string>',
'upload' => [
'filename' => '<string>',
'content_type' => '<string>',
'size_bytes' => 2
],
'object_min_z' => 123,
'spawn_zones' => [
[
]
],
'initial_pose' => [
],
'up_axis' => '<string>',
'rotate_deg' => [
123
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.kiteml.com/v1/environments"
payload := strings.NewReader("{\n \"name\": \"<string>\",\n \"description\": \"<string>\",\n \"usd_uri\": \"<string>\",\n \"glb_uri\": \"<string>\",\n \"upload\": {\n \"filename\": \"<string>\",\n \"content_type\": \"<string>\",\n \"size_bytes\": 2\n },\n \"object_min_z\": 123,\n \"spawn_zones\": [\n {}\n ],\n \"initial_pose\": {},\n \"up_axis\": \"<string>\",\n \"rotate_deg\": [\n 123\n ]\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.kiteml.com/v1/environments")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"name\": \"<string>\",\n \"description\": \"<string>\",\n \"usd_uri\": \"<string>\",\n \"glb_uri\": \"<string>\",\n \"upload\": {\n \"filename\": \"<string>\",\n \"content_type\": \"<string>\",\n \"size_bytes\": 2\n },\n \"object_min_z\": 123,\n \"spawn_zones\": [\n {}\n ],\n \"initial_pose\": {},\n \"up_axis\": \"<string>\",\n \"rotate_deg\": [\n 123\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.kiteml.com/v1/environments")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"name\": \"<string>\",\n \"description\": \"<string>\",\n \"usd_uri\": \"<string>\",\n \"glb_uri\": \"<string>\",\n \"upload\": {\n \"filename\": \"<string>\",\n \"content_type\": \"<string>\",\n \"size_bytes\": 2\n },\n \"object_min_z\": 123,\n \"spawn_zones\": [\n {}\n ],\n \"initial_pose\": {},\n \"up_axis\": \"<string>\",\n \"rotate_deg\": [\n 123\n ]\n}"
response = http.request(request)
puts response.read_body{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}Authorizations
A Kite API key (kite_...), from Platform API → Keys in the dashboard.
Headers
The dated contract your code was written against. Without it you get 2026-09-27; every response says which version served it.
Available options:
2026-09-27 Body
application/json
Maximum string length:
160Maximum string length:
2000Show child attributes
Show child attributes
z (m) below which a dropped object counts as fallen; default -0.2
[{name?, x, y, z?, radius?}] where objects may be placed
{position_xyz:[x,y,z], rotation_xyzw?:[x,y,z,w]}
'Y' or 'Z' — how the geometry is authored
extra [rx, ry, rz] rotation in degrees
Response
Successful Response
⌘I
Create Environment
curl --request POST \
--url https://api.kiteml.com/v1/environments \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"name": "<string>",
"description": "<string>",
"usd_uri": "<string>",
"glb_uri": "<string>",
"upload": {
"filename": "<string>",
"content_type": "<string>",
"size_bytes": 2
},
"object_min_z": 123,
"spawn_zones": [
{}
],
"initial_pose": {},
"up_axis": "<string>",
"rotate_deg": [
123
]
}
'import requests
url = "https://api.kiteml.com/v1/environments"
payload = {
"name": "<string>",
"description": "<string>",
"usd_uri": "<string>",
"glb_uri": "<string>",
"upload": {
"filename": "<string>",
"content_type": "<string>",
"size_bytes": 2
},
"object_min_z": 123,
"spawn_zones": [{}],
"initial_pose": {},
"up_axis": "<string>",
"rotate_deg": [123]
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
name: '<string>',
description: '<string>',
usd_uri: '<string>',
glb_uri: '<string>',
upload: {filename: '<string>', content_type: '<string>', size_bytes: 2},
object_min_z: 123,
spawn_zones: [{}],
initial_pose: {},
up_axis: '<string>',
rotate_deg: [123]
})
};
fetch('https://api.kiteml.com/v1/environments', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.kiteml.com/v1/environments",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'name' => '<string>',
'description' => '<string>',
'usd_uri' => '<string>',
'glb_uri' => '<string>',
'upload' => [
'filename' => '<string>',
'content_type' => '<string>',
'size_bytes' => 2
],
'object_min_z' => 123,
'spawn_zones' => [
[
]
],
'initial_pose' => [
],
'up_axis' => '<string>',
'rotate_deg' => [
123
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.kiteml.com/v1/environments"
payload := strings.NewReader("{\n \"name\": \"<string>\",\n \"description\": \"<string>\",\n \"usd_uri\": \"<string>\",\n \"glb_uri\": \"<string>\",\n \"upload\": {\n \"filename\": \"<string>\",\n \"content_type\": \"<string>\",\n \"size_bytes\": 2\n },\n \"object_min_z\": 123,\n \"spawn_zones\": [\n {}\n ],\n \"initial_pose\": {},\n \"up_axis\": \"<string>\",\n \"rotate_deg\": [\n 123\n ]\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.kiteml.com/v1/environments")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"name\": \"<string>\",\n \"description\": \"<string>\",\n \"usd_uri\": \"<string>\",\n \"glb_uri\": \"<string>\",\n \"upload\": {\n \"filename\": \"<string>\",\n \"content_type\": \"<string>\",\n \"size_bytes\": 2\n },\n \"object_min_z\": 123,\n \"spawn_zones\": [\n {}\n ],\n \"initial_pose\": {},\n \"up_axis\": \"<string>\",\n \"rotate_deg\": [\n 123\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.kiteml.com/v1/environments")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"name\": \"<string>\",\n \"description\": \"<string>\",\n \"usd_uri\": \"<string>\",\n \"glb_uri\": \"<string>\",\n \"upload\": {\n \"filename\": \"<string>\",\n \"content_type\": \"<string>\",\n \"size_bytes\": 2\n },\n \"object_min_z\": 123,\n \"spawn_zones\": [\n {}\n ],\n \"initial_pose\": {},\n \"up_axis\": \"<string>\",\n \"rotate_deg\": [\n 123\n ]\n}"
response = http.request(request)
puts response.read_body{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"type": "<string>",
"code": "<string>",
"message": "<string>",
"param": "<string>",
"request_id": "<string>",
"details": {}
}
}